//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 変換メッシュヘッダ
 * @author Junpee
 */

#ifndef TRANSLATION_MESH_H_
#define TRANSLATION_MESH_H_

namespace Lamp{
	class Scene;
}

namespace LampForMaya{

class TranslationRigidMesh;
class TranslationCharacterMesh;

//------------------------------------------------------------------------------
/**
 * 変換メッシュ
 */
class TranslationMesh{
friend class TranslationMeshManager;
public:
	/**
	 * デストラクタ
	 */
	virtual ~TranslationMesh();

	/**
	 * Lampへの変換
	 * @param scene シーン
	 * @return 成功すればtrue
	 */
	virtual bool convertToLamp(Scene* scene) = 0;

	/**
	 * 名前の取得
	 * @return 名前
	 */
	virtual String getName() const{ return name_; }

	/**
	 * ピボットのコンパイル
	 * @param pivot ピボット位置
	 */
	virtual void compilePivot(const Vector3& pivot){}

	/**
	 * 論理チェック
	 * @return 成功すればtrue
	 */
	virtual bool logicalCheck() = 0;

	//--------------------------------------------------------------------------
	/**
	 * マテリアル名の設定
	 * @param materialName マテリアル名
	 */
	virtual void setMaterialName(const String& materialName){
		materialName_ = materialName;
	}

	/**
	 * 位置の追加
	 * @param position 追加する位置
	 */
	virtual void addPosition(const Vector3& position){
		positions_.add(position);
	}

	/**
	 * 法線の追加
	 * @param normal 追加する法泉
	 */
	virtual void addNormal(const Vector3& normal){ normals_.add(normal); }

	/**
	 * 色の追加
	 * @param color 追加する色
	 */
	virtual void addColor(const Color4f& color){ colors_.add(color); }

	/**
	 * UVの追加
	 * @param uv 追加するUV
	 */
	virtual void addUV(const TexCoord2& uv){ uvs_.add(uv); }

	/**
	 * UVセット数の設定
	 * @param uvSetCount UVセット数
	 */
	virtual void setUVSetCount(int uvSetCount){ uvSetCount_ = uvSetCount; }

	//--------------------------------------------------------------------------
	// RTTI
	//--------------------------------------------------------------------------
	/**
	 * 剛体メッシュかどうか
	 * @return 剛体メッシュならtrue
	 */
	virtual bool isRigidMesh() const{ return false; }

	/**
	 * 剛体メッシュへのキャスト
	 * @return 剛体メッシュ。型が違えばNULLを返す。
	 */
	virtual TranslationRigidMesh* castRigidMesh() const{
		if(isRigidMesh()){
			return (TranslationRigidMesh*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------
	/**
	 * キャラクタメッシュかどうか
	 * @return キャラクタメッシュならtrue
	 */
	virtual bool isCharacterMesh() const{ return false; }

	/**
	 * キャラクタメッシュへのキャスト
	 * @return キャラクタメッシュ。型が違えばNULLを返す。
	 */
	virtual TranslationCharacterMesh* castCharacterMesh() const{
		if(isCharacterMesh()){
			return (TranslationCharacterMesh*)this;
		}
		return NULL;
	}

	//--------------------------------------------------------------------------

protected:
	/**
	 * コンストラクタ
	 * @param initializeName 初期化する名前
	 */
	TranslationMesh(const String& initializeName);

	/**
	 * 頂点論理チェック
	 * @return 正常ならture
	 */
	virtual bool vertexLogicalCheck();

	/// 名前
	String name_;
	/// マテリアル名
	String materialName_;
	/// 位置配列
	ArrayList<Vector3> positions_;
	/// 法線配列
	ArrayList<Vector3> normals_;
	/// 色配列
	ArrayList<Color4f> colors_;
	/// UV配列
	ArrayList<TexCoord2> uvs_;
	/// UVセット数
	int uvSetCount_;

private:
	// コピーコンストラクタの隠蔽
	TranslationMesh(const TranslationMesh& copy);

	// 代入コピーの隠蔽
	void operator =(const TranslationMesh& copy);


};

//------------------------------------------------------------------------------
} // End of namespace LampForMaya
#endif // End of TRANSLATION_MESH_H_
//------------------------------------------------------------------------------
